public enum PostgreSQLPrimaryKeyDefault: SQLPrimaryKeyDefault {
    public enum Generated {
        case byDefault
        case always
    }
    case generated(Generated)
    
    public static var `default`: PostgreSQLPrimaryKeyDefault {
        return .generated(.byDefault)
    }
    
    public func serialize(_ binds: inout [Encodable]) -> String {
        switch self {
        case .generated(let generated):
            switch generated {
            case .always: return "GENERATED ALWAYS AS IDENTITY"
            case .byDefault: return "GENERATED BY DEFAULT AS IDENTITY"
            }
        }
    }
}
